<?php

namespace Statamic\Addons\Metapod;

use Statamic\Extend\Tags;
use Stringy\StaticStringy as Str;
use Statamic\Addons\Metapod\Helpers as Metapod;

class MetapodTags extends Tags
{
    /**
     * Pseudo-constructor.
     *
     * @author Curtis Blackwell
     * @return void
     */
    public function init()
    {
        $this->helper = new Metapod;
    }

    /**
     * Get meta tags from a page.
     *
     * @author Curtis Blackwell
     * @return array
     */
    public function index()
    {
        $url       = $this->getParam(['url', 'link']);
        $cacheName = Str::slugify($url);

        // Return cache data if it exists.
        if ($data = $this->cache->get($cacheName)) {
            return $data;
        }

        $html = $this->helper->getHTML($url);
        $vars = $this->helper->getMetaTagsForTemplate($html);

        // Cache the data.
        $this->cache->put($cacheName, $vars);

        return $vars;
    }
}
